************************************************************
*                                                          *
*                       Stata与python交互系统              *
*                                                          *
************************************************************
****************************************
****************************************
/*Stata与python交互调用jieba进行分词*/
******************************************
*全模式
*!pip install jieba
clear all
cd E:\Stata大会\文本分析
tempname handle
file open `handle' using 分词.py, replace text write
file write `handle' `"# -*- coding: utf-8 -*-"' _n
file write `handle' `"import jieba"' _n
file write `handle' `"string ="曲曲折折的荷塘上面，弥望的是田田的叶子。"'
file write `handle' `"叶子出水很高，像亭亭的舞女的裙。""'_n
file write `handle' `"seg_list = jieba.cut(string, cut_all = True)"' _n
file write `handle' `"for word in seg_list:"' _n
file write `handle' `"	print(word)"'
file close `handle'
winexec notepad 分词.py
! python 分词.py > 分词结果.txt
shellout 分词结果.txt
**********词频统计
clear
cd E:\Stata大会\文本分析
import delimited using 分词结果.txt, clear encoding("gb18030") ///
	varnames(nonames)
rename v1 keyword
levelsof keyword, local(keyword)
bysort keyword: gen frequency = _N
duplicates drop
*精确模式
clear all
cd E:\Stata大会\文本分析
tempname handle
file open `handle' using 分词.py, replace text write
file write `handle' `"# -*- coding: utf-8 -*-"' _n
file write `handle' `"import jieba"' _n
file write `handle' `"string ="曲曲折折的荷塘上面，弥望的是田田的叶子。"'
file write `handle' `"叶子出水很高，像亭亭的舞女的裙。""'_n
file write `handle' `"seg_list = jieba.cut(string, cut_all = False)"' _n
file write `handle' `"for word in seg_list:"' _n
file write `handle' `"	print(word)"'
file close `handle'
winexec notepad 分词.py
! python 分词.py > 分词结果.txt
shellout 分词结果.txt
*********词频统计
clear
cd E:\Stata大会\文本分析
import delimited using 分词结果.txt, clear encoding("gb18030") ///
	varnames(nonames)
rename v1 keyword
levelsof keyword, local(keyword)
bysort keyword: gen frequency = _N
duplicates drop
*标注词性
clear all
cd E:\Stata大会\文本分析
tempname handle
file open `handle' using 分词.py, replace text write
file write `handle' `"# -*- coding: utf-8 -*-"' _n
file write `handle' `"import jieba.posseg"' _n
file write `handle' `"string ="曲曲折折的荷塘上面，弥望的是田田的叶子。"'
file write `handle' `"叶子出水很高，像亭亭的舞女的裙。""'_n
file write `handle' `"seg_list = jieba.posseg.cut(string)"' _n
file write `handle' `"for word in seg_list:"' _n
file write `handle' `"	print(word.word, word.flag)"'
file close `handle'
winexec notepad 分词.py
! python 分词.py > 分词结果.txt
shellout 分词结果.txt
*********词频统计
clear
cd E:\Stata大会\文本分析
import delimited using 分词结果.txt, clear encoding("gb18030") ///
	varnames(nonames)
split v1,p(" ")
drop v1 
rename v11 keyword
levelsof keyword, local(keyword)
bysort keyword: gen frequency = _N
duplicates drop
*********添加词典进行分词
clear all
cd  E:\Stata大会\文本分析
tempname handle
file open `handle' using 分词.py, replace text write
file write `handle' `"# -*- coding: utf-8 -*-"' _n
file write `handle' `"import jieba.posseg"' _n
file write `handle' `"jieba.load_userdict("E:/Stata大会/文本分析/dict.txt")"' _n
file write `handle' `"string ="曲曲折折的荷塘上面，弥望的是田田的叶子。"'
file write `handle' `"叶子出水很高，像亭亭的舞女的裙。""'_n
file write `handle' `"seg_list = jieba.posseg.cut(string)"' _n
file write `handle' `"for word in seg_list:"' _n
file write `handle' `"	print(word.word, word.flag)"'
file close `handle'
winexec notepad 分词.py
! python 分词.py > 分词结果.txt
shellout 分词结果.txt
*********词频统计
clear
cd E:\Stata大会\文本分析
import delimited using 分词结果.txt, clear encoding("gb18030") ///
	varnames(nonames)
split v1,p(" ")
drop v1 
rename v11 keyword
levelsof keyword, local(keyword)
bysort keyword: gen frequency = _N
duplicates drop

